/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.part;

import java.sql.Connection;
import java.util.Properties;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.InstanceFactory;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.utils.VariousUtil;

/**
 * 各種Partクラスの基本となるクラス
 * @author yoshida
 *	@version	0.0.4
 */
public abstract class BasePart {
	
	/**
	 *  MosPアプリケーション設定(/WEB-INF/mosp.properties)。
	 */
	protected Properties	cfg;
	/**
	 * リクエストされたCommand。
	 */
	protected String		cmd;
	/**
	 * ログインASPユーザー。
	 */
	protected CmAspUserDto	aspUser;
	/**
	 * ログインユーザー。
	 */
	protected CmUserDto		user;
	/**
	 * DBコネクション。
	 */
	protected Connection	conn;
	

	/**
	 * コンストラクタ
	 */
	public BasePart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo	Partを利用する際に必要な情報
	 */
	public BasePart(PartInfo partInfo) {
		this();
		init(partInfo);
	}
	
	/**
	 * 初期化
	 * @param partInfo	Partを利用する際に必要な情報
	 */
	public void init(PartInfo partInfo) {
		init(partInfo.getCfg(), partInfo.getCmd(), partInfo.getAspUser(), partInfo.getUser(), partInfo.getConn());
	}
	
	/**
	 * 初期化
	 * @param cfg	MosPアプリケーション設定(/WEB-INF/mosp.properties)。
	 * @param cmd	リクエストされたCommand。
	 * @param aspUser	ログインASPユーザー。
	 * @param user	ログインユーザー。
	 * @param conn 	DBコネクション。
	 */
	public void init(Properties cfg, String cmd, CmAspUserDto aspUser, CmUserDto user, Connection conn) {
		this.cfg = cfg;
		this.cmd = cmd;
		this.aspUser = aspUser;
		this.user = user;
		this.conn = conn;
	}
	

	/**
	 * DAOフィールド
	 */
	private BaseDao	dao;
	

	/**
	 * 初期化済みDAO生成
	 * @param className		対象DAOクラス名称
	 * @return				対象初期化済みDAOインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	protected BaseDao getPreparedDao(String className) throws MospException {
		// DAO準備
		if (dao == null || !dao.getClass().getName().equals(className)) {
			Object obj = InstanceFactory.loadInstance(className);
			if (obj instanceof BaseDao) {
				dao = (BaseDao)obj;
				dao.initDao(cfg, cmd, aspUser, user, conn);
			} else {
				final int exCode = 5014;
				throw new MospException(exCode, className + " is not instanceof BaseDao class.");
			}
		}
		return dao;
	}
	
	/**
	 * 初期化済みDAO生成
	 * @param cls 対象DAOクラス
	 * @return 対象初期化済みDAOインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	protected BaseDao getPreparedDao(Class<?> cls) throws MospException {
		return getPreparedDao(cls.getCanonicalName());
	}
	

	private BaseStore	baseStore;
	

	/**
	 * 対象PartStoreインスタンス取得。
	 * @since	0.0.4
	 * @return	PartStoreインスタンス
	 * @throws MospException  MosP例外処理が発生した場合
	 */
	protected PartStore part() throws MospException {
		return (PartStore)getBaseStore(PartStore.class);
	}
	
	/**
	 * 対象Storeインスタンス取得。
	 * @since 0.0.5
	 * @param cls BaseStoreを継承したクラス
	 * @return BaseStoreインスタンス
	 * @throws MospException  MosP例外処理が発生した場合
	 */
	protected BaseStore getBaseStore(Class<?> cls) throws MospException {
		if (VariousUtil.isNull(baseStore)) {
			baseStore = (BaseStore)InstanceFactory.loadInstance(cls.getCanonicalName());
			baseStore.setPartInfo(PartManager.createPartInfo(cfg, cmd, aspUser, user, conn));
		}
		return baseStore;
	}
	
}
